SAW_COLOR_PURPLE			= "|cFFaa55cc"
SAW_COLOR_YELLOW			= "|cFFffff00"
SAW_COLOR_DRED				= "|cFFcc0000"
SAW_COLOR_BLUE				= "|cFF0000cc"
SAW_COLOR_MGREEN			= "|cFF01ff01"
SAW_COLOR_MRED				= "|CFFff0101"
SAW_COLOR_Junk				= "|cFF9d9d9d"
SAW_COLOR_Common			= "|cFFffffff"
SAW_COLOR_Uncommon			= "|cFF1eff00"
SAW_COLOR_Rare				= "|cFF0070dd"
SAW_COLOR_Epic				= "|cFFa335ee"
SAW_COLOR_Lengendary		= "|cFFff8000"
SAW_COLOR_Disable			= "|cFF555555"
SAW_COLOR_Enable			= "|cFF00ff00"


local function SAW_COLOR(s,c)
	s = s.."|r"
	if(_G["SAW_COLOR_"..c]) then
		return _G["SAW_COLOR_"..c]..s
	end
	return c..s
end

function round_(number, decimals)
    return (("%%.%df"):format(decimals)):format(number)
end

function formatTime(fmins)
	local hours = math.floor(fmins / 60)
	local mins = math.floor(((fmins / 60)%1)*60)
	local secs = round_((fmins%1)*60, 0)

	return ("%02d:%02d:%02d"):format(hours, mins, secs)
end
	

function getMillis()
	return round_(GetTime()*1000,0)
end

local function resolveItem(itemData)
	obj = {}
	index = 0
	for x in string.gmatch(itemData, "%w+") do
		obj[index] = x
		index = index + 1
		--print(x)
	end
	return obj
end

local function splitItem(itemLink) 
	return strsplit("|", itemLink)
end

local function ShowHelp()
  	return (IsAltKeyDown() and true) or false
end

-- skinning support
function SkinFrame(frame,name)
  -- default behavior
  if IsAddOnLoaded("ElvUI") or IsAddOnLoaded("Tukui") then
    if frame.StripTextures then
      frame:StripTextures()
    end
    if frame.SetTemplate then
      frame:SetTemplate("Transparent")
    end
    local close = _G[name.."CloseButton"] or frame.CloseButton
    if close and close.SetAlpha then
      if ElvUI then
        ElvUI[1]:GetModule('Skins'):HandleCloseButton(close)
      end
      if Tukui and Tukui[1] and Tukui[1].SkinCloseButton then
        Tukui[1].SkinCloseButton(close)
      end
      close:SetAlpha(1)
    end

    local editbox = _G[name.."EditBox"] or frame.EditBox
    if editbox and editbox.SetAlpha then
    	if (editbox.StripTextures) then
    		editbox:StripTextures()
    	end
      if ElvUI then
        editbox:SetTemplate("Transparent")
        --ElvUI[1]:GetModule('Skins'):HandleEditBox(editbox)
      end
      if Tukui and Tukui[1] and Tukui[1].SkinEditBox then
      	editbox:SetTemplate("Transparent")

        --Tukui[1].SkinEditBox(editbox)
      end
      editbox:SetAlpha(1)
    end
  end
end





local LibQTip = LibStub('LibQTip-1.0')
local TextLib = LibStub('LibTextMsg-1.0')

local trackedItems = {}
local frames = {}
local maxcol = 3

local DT_HEADER 	= SAW_COLOR("DropTrak: ", "PURPLE")
local DT_VERSION	= "v1.3a"
local DT_money		= GetMoney()
local start_gold 	= 0
local gold_now		= 0
local DT_total		= 0
local DT_t_str		= ""
local g_str			= ""


function DT_AddItemToTracker(flag_isItemData, itemStuff)
	if (flag_isItemData == false) then
		local link = select(2, GetItemInfo(itemStuff))
		local null,color,itemData,idk = splitItem(link)
		itemStuff = itemData
	end


	local scrap = resolveItem(itemStuff)
	local itemId = scrap[1]
	local itemType = string.sub(scrap[0], 2)

	if itemType ~= "item" then
		print(DT_HEADER .. itemId .. " is not an item")
		TextLib:TextMessage(itemId .. " is not an item")
		return
	end

	boolThere = false
	for k,v in ipairs(trackedItems) do
	   	if (v.id == itemId) then
	   		boolThere = true
	   	end
	end
	if not boolThere then
		--trackedItems[#trackedItems+1] = {id = itemId, quantity = 0, rate = ""} --need to change the way stuff gets stored as its not incrementing the size correctly
		table.insert(trackedItems, {id = itemId, quantity = 0, rate = ""})
		print(DT_HEADER .. select(1, GetItemInfo(tonumber(itemId))) .. " is now tracked")
		TextLib:TextMessage(select(1, GetItemInfo(tonumber(itemId))) .. " is now tracked")
	else
		print(DT_HEADER .. select(1, GetItemInfo(tonumber(itemId))) .. " is already tracked")
		TextLib:TextMessage(select(1, GetItemInfo(tonumber(itemId))) .. " is already tracked")
	end
end


print(DT_HEADER .. SAW_COLOR(" ~~~ Libs Loaded!", "YELLOW"))
local RateTimeStart = getMillis();

local DT_Frame = CreateFrame("Frame", "DTFrame", UIParent)
DT_Frame:SetBackdrop(GameTooltip:GetBackdrop())
DT_Frame:SetBackdropColor(GameTooltip:GetBackdropColor())
DT_Frame:SetSize(256,48)
DT_Frame:SetScale(1)
DT_Frame:SetPoint("CENTER",0,0)
DT_Frame:SetClampedToScreen(true)
DT_Frame:EnableMouse(true)
DT_Frame:SetMovable(true)
DT_Frame:SetUserPlaced(true)
DT_Frame.tooltipUpdateTime = 0;
DT_Frame.tooltipUpdateInterval = 0.5;


local DT_Frame_FS = DT_Frame:CreateFontString()
DT_Frame_FS:SetFont("Fonts\\ARIALN.TTF", 22, "OUTLINE") --Fonts\\FRIZQT__.TTFFonts\\SKURRI.TTF -  -
--DT_Frame_FS:SetSize(170, 25)
DT_Frame_FS:SetJustifyH("RIGHT")
DT_Frame_FS:SetJustifyV("MIDDLE")
DT_Frame_FS:SetPoint("TOPRIGHT", -35, -5)
--DT_Frame_FS:SetAlpha(0.8)
DT_Frame_FS:SetText("Loading...")

local DT_Reset = CreateFrame("Button", DT_Frame:GetName().."CloseButton", DT_Frame) --, "UIPanelButtonTemplate"
DT_Reset:SetNormalTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Up")
DT_Reset:SetPushedTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Down")
DT_Reset:SetHighlightTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Highlight") -- "BLEND"
DT_Reset:SetDisabledTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Disabled")
DT_Reset.tooltip = "Toggle Popout"
DT_Reset:SetPoint("TOPRIGHT", 0,0)
DT_Reset:SetSize(32,32)

--[[
local DT_Expand = CreateFrame("Button", "DT_Expand_Button", DT_Frame) --, "UIPanelButtonTemplate"
DT_Expand:SetNormalTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Up")
DT_Expand:SetPushedTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Down")
DT_Expand:SetHighlightTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Highlight") -- "BLEND"
DT_Expand:SetDisabledTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Disabled")
DT_Expand.tooltip = "Expand"
DT_Expand:SetPoint("TOPRIGHT", -21, 0)
DT_Expand:SetSize(32,32)
]]--

local DT_EDITBOX = CreateFrame("EditBox", DT_Frame:GetName().."EditBox", DT_Frame)
DT_EDITBOX:SetWidth(DT_Frame:GetWidth())
DT_EDITBOX:SetHeight(20)
DT_EDITBOX:SetPoint("TOPLEFT", DT_EDITBOX:GetParent(), "BOTTOMLEFT", 0, 20)
DT_EDITBOX:SetTextInsets(5, 5, 0, 0)

DT_EDITBOX:CreateFontString(nil, "OVERLAY", "GameFontHighlight")
DT_EDITBOX:SetFont("FRIZQT__.TTF", 22, "OUTLINE")
DT_EDITBOX:SetFontObject("GameFontHighlight")
DT_EDITBOX:ClearFocus(self)
DT_EDITBOX:SetAutoFocus(false)

DT_EDITBOX:SetBackdrop(GameTooltip:GetBackdrop())
DT_EDITBOX:SetBackdropColor(1, 1, 1)

DT_EDITBOX:SetScript("OnEditFocusGained", function(self) 
							OpenAllBags(nil)
							end
						)
DT_EDITBOX:SetScript("OnEscapePressed", function(self)
								self:ClearFocus()
								print(DT_HEADER .. "Focus Cleared")
							end
						)

DT_EDITBOX:SetScript("OnEnterPressed", function(self)
								self:ClearFocus()
								local text = self:GetText()
								self:SetText("")
								print(DT_HEADER .. "Enter pressed")

								local null,color,itemData,idk = splitItem(text)
								--print(string.gsub(text, "%|", ","))
								--print(color)
								--print(itemData)
								--print(string.split(":", itemData))
								--print(idk)
								--[[


								local scrap = resolveItem(itemData)
	   							local itemId = scrap[1]
	   							local itemType = string.sub(scrap[0], 2)

	   							if itemType ~= "item" then
	   								print(DT_HEADER .. itemId .. " is not an item")
									TextLib:TextMessage(itemId .. " is not an item")
									return
	   							end

	   							boolThere = false
	   							for k,v in ipairs(trackedItems) do
	   								if (v.id == itemId) then
	   									boolThere = true
	   								end
	   							end
	   							if not boolThere then
									--trackedItems[#trackedItems+1] = {id = itemId, quantity = 0, rate = ""} --need to change the way stuff gets stored as its not incrementing the size correctly
									table.insert(trackedItems, {id = itemId, quantity = 0, rate = ""})
									print(DT_HEADER .. select(1, GetItemInfo(tonumber(itemId))) .. " is now tracked")
									TextLib:TextMessage(select(1, GetItemInfo(tonumber(itemId))) .. " is now tracked")
								else
									print(DT_HEADER .. select(1, GetItemInfo(tonumber(itemId))) .. " is already tracked")
									TextLib:TextMessage(select(1, GetItemInfo(tonumber(itemId))) .. " is already tracked")
								end

								]]
								DT_AddItemToTracker(true, itemData)
								
							end
						)
																		--GETTING THERE SLOWLY
DT_Frame.EditBox = DT_EDITBOX
																		
Orig_ChatEdit_InsertLink = ChatEdit_InsertLink
-- YourEditBox takes priority. If you want the default frames to take priority, then you will have to copy the entire function from FrameXML\ChatFrame.lua (replace rather than hook).
function ChatEdit_InsertLink(text) -- Prioritizes DT_EDITBOX
  if text and DT_EDITBOX:HasFocus() and DT_EDITBOX:IsVisible() then
    DT_EDITBOX:Insert(text)
    return true
  else
    Orig_ChatEdit_InsertLink(text)
  end
end

DT_Reset:Show()
DT_Frame:Show()


DT_Frame:RegisterEvent("ADDON_LOADED")
DT_Frame:RegisterEvent("PLAYER_MONEY")
DT_Frame:RegisterEvent("PLAYER_LOGIN")
DT_Frame:RegisterEvent("PLAYER_LOGOUT")
DT_Frame:RegisterEvent("CHAT_MSG_LOOT")
--DT_Frame:RegisterEvent("MODIFIER_STATE_CHANGED") --thinking about just IsAltKeyDown instead


-- Core Routines/Functions --

function comma_value(n) -- credit http://richard.warburton.it
	local left,num,right = string.match(n,'^([^%d]*%d)(%d*)(.-)$')
	return left..(num:reverse():gsub('(%d%d%d)','%1,'):reverse())..right
end

SLASH_DROPTRAK1 = "/droptrak"
SLASH_DROPTRAK2 = "/dt"
SlashCmdList["DROPTRAK"] = function(msg)
	local command, itemid = msg:match("^(%S*)%s*(.-)$");
	if (not msg or msg == "" or msg == "help") then
		print("DropTrak help:")
		print("  /dt show    -  Shows DropTrak frame")
		print("  /dt hide   -  Hides DropTrak frame")
		print("  /dt track [itemId/itemLink]      -  Enter (itemId / shift-click link) to add to tracker")
	elseif (msg == "show") then
		DT_Frame:Show()
	elseif (msg == "hide") then
		DT_Frame:Hide()
	elseif (command == "track") then 
		DT_AddItemToTracker(false, itemid)
	end
end


local function updateWindowSizeW(width)
	DT_Frame:SetWidth(width)

	DT_EDITBOX:SetWidth(width)

	--DT_Frame:SetWidth(width)
end
	

local function Update_Gold()
	
	local tag 		= ""
	local DT_tag 	= ""
	local old_str 	= DT_Frame_FS:GetText()
	
	gold_now 	= GetMoney()
	
	-- Gold since reset. --
	if(gold_now < start_gold) then
		gold_now 	= start_gold - gold_now
		tag 		= "- "
	elseif(GetMoney() > start_gold) then
		gold_now 	= gold_now - start_gold
		tag 		= "+ "
	else
		gold_now 	= 0
		tag 		= "" 
	end
	
	-- Gold since session start. --
	--print(GetMoney())
	--print(DT_money)
	if(GetMoney() < DT_money) then
		DT_total 	= DT_money - GetMoney()
		DT_tag 		= "- "
	elseif(GetMoney() > DT_money) then
		DT_total 	= GetMoney() - DT_money
		DT_tag 		= "+ "
	else
		DT_total 	= 0
		DT_tag 		= "" 
	end
	
	DT_t_str		= comma_value(DT_tag..GetCoinTextureString(DT_total, 10))
	
	if(DT_tag == "+ ") then
		DT_t_str 	= SAW_COLOR(DT_t_str, "MGREEN")
	elseif(DT_tag == "- ") then
		DT_t_str	= SAW_COLOR(DT_t_str, "MRED")
	end
	
	gold_now 		= comma_value(GetCoinTextureString(gold_now, 10))
	
	g_str 			= tag..gold_now	
	
	if(tag == "+ ") then 
		g_str 		= SAW_COLOR(g_str, "MGREEN")
	elseif(tag == "- ") then 
		g_str 		= SAW_COLOR(g_str, "MRED") 
	end
	
	if(g_str ~= old_str) then
		DT_Frame_FS:SetText(g_str)
		updateWindowSizeW(DT_Frame_FS:GetWidth() + 42)
		DT_Frame_FS:SetAlpha(1.0)
	end
end

 local function anchor_OnEnter(self)
	 
	   -- Acquire a tooltip with 3 columns, respectively aligned to left, center and right
	local tooltip-- = LibQTip:Acquire("FooBarTooltip", 4, "LEFT", "CENTER", "RIGHT", "RIGHT")
		tooltip = LibQTip:Acquire("ExpandTip", maxcol, "LEFT", "CENTER", "RIGHT")
			
	
	self.tooltip = tooltip
	tooltip:SetPoint("TOPLEFT", DT_Frame, "BOTTOMLEFT", 10)
	tooltip:SmartAnchorTo(DT_Frame)
	   -- Add an header filling only the first two columns
	  --tooltip:AddHeader('Anchor', 'Tooltip')
		
	tooltip:AddHeader(DT_HEADER.. DT_VERSION, "", "")
	
	tooltip:AddLine('Click x to reset', '', '')
	tooltip:AddSeparator(1)
	tooltip:AddLine('Gold At Login:', '', comma_value(GetCoinTextureString(DT_money, 10)) .. ' ')
	tooltip:AddLine('Gold Now:', '', comma_value(GetCoinTextureString(GetMoney(), 10)) .. ' ')
	tooltip:AddLine('Total Change', '', DT_t_str .. ' ')
	tooltip:AddSeparator(1)

	tooltip:AddLine('ID', 'Amount (Session)', 'Rate')
	tooltip:AddSeparator(1)

		 -- Add an empty line we will add cell to
	 local y ,x = tooltip:AddLine()
 
	for k,v in pairs(trackedItems) do
		itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(v.id)
		tooltip:AddLine(itemLink, v.quantity, v.rate)
	end 

	tooltip:AddSeparator(1)
 

   -- Use smart anchoring code to anchor the tooltip to our frame
   --tooltip:SmartAnchorTo(self)
   
   -- Show it, et voilà !
   self.tooltip:Show()
   
 end
 
 local function anchor_OnLeave(self)
 	-- if (self.tooltip ~= nil) then
  --  		self.tooltip:Hide()
  --  	end
   	-- Release the tooltip
   	LibQTip:Release(self.tooltip)
   	self.tooltip = nil
   
 end

local isMoving = false
local isMouseOver = false

local showExpandTip = false

local fadeTime = 0
--local goldCheck = 0

--tooltip = nil;
local tooltip, subtooltip

local function DT_OnUpdate(self, t)

		if(fadeTime < GetTime() - 0.75) then
			local a = DT_Frame_FS:GetAlpha()
			local b = DT_Reset:GetAlpha()
			if(a >= 0.5 and not isMouseOver) then 
				DT_Frame_FS:SetAlpha(a - 0.025)
			end
			if(b >= 0.5 and not isMouseOver) then 
				DT_Reset:SetAlpha(b - 0.025)
			end
		end

		--RateTracker
		curTime = getMillis()
		for k,v in pairs(trackedItems) do
				v.rate = round_(v.quantity / ((curTime - RateTimeStart)/1000/60), 3)
				--v.rate = v.quantity / ((curTime - RateTimeStart)/1000)
		end

		if (isMouseOver) then
			--anchor_OnEnter(DT_Expand)
			--showToolTip()
		else 
			--anchor_OnLeave(DT_Expand)
			
		end



		--[[
		if(isMouseOver) then
			if(GameTooltip:GetOwner() ~= self) then
				GameTooltip:SetOwner(self, "ANCHOR_TOPLEFT")
				GameTooltip:AddLine(DT_HEADER.. "v1.0")
				GameTooltip:AddLine("click x to reset GoldTracker display.")
				GameTooltip:AddLine(" ")
				GameTooltip:AddDoubleLine("Gold At Login:", comma_value(GetCoinTextureString(DT_money, 10)))
				GameTooltip:AddDoubleLine("Gold Now:", comma_value(GetCoinTextureString(GetMoney(), 10)))
				GameTooltip:AddLine("Total Gold Made/Lost Since Login:")
				GameTooltip:AddDoubleLine(" ", DT_t_str)
				GameTooltip:Show()
			end
		else
			if(GameTooltip:GetOwner() == self) then
				GameTooltip:SetOwner(UIParent, "ANCHOR_NONE")
				GameTooltip:Hide()
			end
		end
		]]--

end

local function closeTooltips() --generic version for morestuff
  GameTooltip:Hide()
  if subtooltip then
     subtooltip:Hide()
  end
end

function closeToolTip()
	LibQTip:Release(tooltip)
	tooltip = nil
end


function showToolTip(anchorframe)
		local showHelp = ShowHelp()

		if tooltip then LibQTip:Release(tooltip) end
		tooltip = LibQTip:Acquire("ExpandTip", maxcol, "LEFT", "CENTER", "CENTER")
		
		tooltip:SetBackdrop(GameTooltip:GetBackdrop())
    	tooltip:SetBackdropColor(GameTooltip:GetBackdropColor()); 
	 	tooltip:SetBackdropBorderColor(GameTooltip:GetBackdropBorderColor())
		SkinFrame(tooltip, "ExpandTip")
		--tooltip = tooltip
		--tooltip:SetPoint("TOPLEFT", anchorframe, "BOTTOMLEFT", 10)
		--tooltip:SmartAnchorTo(anchorframe)
		--tooltip:SetAutoHideDelay(0.25, anchorframe, closeToolTip)

		local headLine = tooltip:AddHeader(DT_HEADER.. DT_VERSION, "", "")
		x,y = tooltip:AddLine()

		tooltip:SetCell(x, y, SAW_COLOR('Time: ', 'Uncommon') .. formatTime(round_((curTime - RateTimeStart)/1000/60, 3)), "LEFT", 1)
		tooltip:SetCellScript(x, y, "OnMouseUp", function() RateTimeStart = getMillis(); TextLib:TextMessage("Time been reset") end)
		
		tooltip:SetCell(x, y+1, SAW_COLOR('Clear', 'MRED') .. ' Items', "CENTER", 1)
		tooltip:SetCellScript(x, y+1, "OnMouseUp", function() trackedItems = {}; TextLib:TextMessage("Items been reset") end)
		
		tooltip:SetCell(x, tooltip:GetColumnCount(), SAW_COLOR('Clear', 'MRED') .. ' Gold', "CENTER", 1)
		tooltip:SetCellScript(x, tooltip:GetColumnCount(), "OnMouseUp", function() start_gold = GetMoney(); Update_Gold(); TextLib:TextMessage("Gold been reset") end)
		
		--tooltip:AddLine('Click x to reset', '', SAW_COLOR('Time running: ', 'Uncommon') .. round_((curTime - RateTimeStart)/1000/60, 3) .. ' mins')
		
		tooltip:AddSeparator(1,1,1,1)

		x,y = tooltip:AddLine()
		tooltip:SetCell(x, y, NORMAL_FONT_COLOR_CODE..'Gold At Login: ', "LEFT", 1)
		tooltip:SetCell(x, tooltip:GetColumnCount(), comma_value(GetCoinTextureString(DT_money, 10)) .. ' ', "RIGHT", 1)
		
		x,y = tooltip:AddLine()
		tooltip:SetCell(x, y, NORMAL_FONT_COLOR_CODE..'Gold Currently: ', "LEFT", 1)
		tooltip:SetCell(x, tooltip:GetColumnCount(), comma_value(GetCoinTextureString(GetMoney(), 10)) .. ' ', "RIGHT", 1)
		
		x,y = tooltip:AddLine()
		tooltip:SetCell(x, y, NORMAL_FONT_COLOR_CODE..'Total Gold Made/Lost Since Login:', "LEFT", tooltip:GetColumnCount()-1)
		tooltip:SetCell(x, tooltip:GetColumnCount(), DT_t_str .. ' ', "RIGHT", 1)
		
		tooltip:AddSeparator(3,1,1,1,0)
		local tableheaders = tooltip:AddHeader(SAW_COLOR('Item', 'Rare'), SAW_COLOR('Amount (Session / Total)', 'Rare'), SAW_COLOR('Rate (/min)', 'Rare'))
		tooltip:AddSeparator(1,1,1,1)

		if table.getn(trackedItems) == 0 then
			x,y = tooltip:AddLine()
			tooltip:SetCell(x, y, 'Tracked Items will fill up this space', "CENTER", tooltip:GetColumnCount())
		end

		for k,v in pairs(trackedItems) do
			itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(v.id)
			x,y = tooltip:AddLine()
			tooltip:SetCell(x, y, itemLink, "LEFT", 1)
			tooltip:SetCellScript(x, y, "OnMouseUp", function ()
				table.remove(trackedItems, k)
				--trackedItems[k] = nil;
				TextLib:TextMessage(select(1, GetItemInfo(v.id)) .. " has been removed")
				end)

			tooltip:SetCell(x, 2, v.quantity .. ' / ' .. GetItemCount(v.id, true, false) .. '', "CENTER", 1)
			tooltip:SetCellScript(x, 2, "OnMouseUp", function ()
				v.quantity = 0
				TextLib:TextMessage(select(1, GetItemInfo(v.id)) .. " quantity has been reset")
				end)

			tooltip:SetCell(x, tooltip:GetColumnCount(), v.rate, "CENTER", 1)
	
		end 

		tooltip:AddSeparator(1,1,1,1)

		-- HELP SECTION
		if not IsDetached() then
			x,y = tooltip:AddLine()
			tooltip:SetCell(x, y, 'Click ' .. SAW_COLOR('X', 'YELLOW') .. ' on tracker to display detached version', "LEFT", tooltip:GetColumnCount())
		end
		
		
		if not showHelp then
			x,y = tooltip:AddLine()
			tooltip:SetCell(x, y, 'Hold ' .. SAW_COLOR('ALT', 'YELLOW') .. ' for help', "LEFT", tooltip:GetColumnCount())
		else
			x,y = tooltip:AddLine();tooltip:SetCell(x, y, 'Track items by linking ' .. SAW_COLOR('(Shift Clicking)', 'YELLOW') .. ' them to the textbox', "LEFT", tooltip:GetColumnCount())
			x,y = tooltip:AddLine();tooltip:SetCell(x, y, 'Clicking item name will ' .. SAW_COLOR('remove', 'MRED') .. ' item', "LEFT", tooltip:GetColumnCount())
			x,y = tooltip:AddLine();tooltip:SetCell(x, y, 'Clicking quantity will ' .. SAW_COLOR('reset', 'MRED') .. ' the quantity in this session', "LEFT", tooltip:GetColumnCount())
			--x,y = tooltip:AddLine();tooltip:SetCell(x, y, 'Is this helping?', "LEFT", tooltip:GetColumnCount())
		end




		---------------------------------------------------------------

		--Updator, this will keep it realish time
		--rowOffset = 9;
		tooltip:SetScript("OnUpdate", function(self, elapsed)
			DT_Frame.tooltipUpdateTime = DT_Frame.tooltipUpdateTime + elapsed;
			if DT_Frame.tooltipUpdateTime > DT_Frame.tooltipUpdateInterval then
				DT_Frame.tooltipUpdateTime = 0;
			if self:IsVisible() then
				showToolTip(anchorframe)
				--[[
				dingle = dingle + 1;
		   		self:SetCell(1,3, '' .. dingle);

				self:SetCell(2, 3, SAW_COLOR('Time running: ', 'Uncommon') .. formatTime(round_((curTime - RateTimeStart)/1000/60, 3)), "LEFT", 1)
				self:SetCell(5, 3, comma_value(GetCoinTextureString(GetMoney(), 10)) .. ' ', "RIGHT", 1)
				self:SetCell(6, 3, DT_t_str .. ' ', "RIGHT", 1)
				
			---TODO: Need to do stuff for the list, and update it, possibly consider adding scrolling to it alotho i wont use it, test it tho cause matloc could use it
				itemInList = 1;
				for k,v in pairs(trackedItems) do
					itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(v.id)
					
					self:SetCell(itemInList+rowOffset, 1, itemInList .. ' - ' .. itemLink, "LEFT", 1)
					self:SetCellScript(itemInList+rowOffset, 1, "OnMouseUp", function ()
						trackedItems[k] = nil;
						TextLib:TextMessage(select(1, GetItemInfo(v.id)) .. " has been removed")
						
						self:SetCell(itemInList+rowOffset, 1, itemInList, "RIGHT", 1) 
						--Trying to make a fucntion that will clean the removed thing up and make it nicer looking, need to look into clearing the diffferent things with a temp val so that it can then redo it when reshown
						end)

					self:SetCell(itemInList+rowOffset, 2, v.quantity .. ' / ' .. GetItemCount(v.id, true, false) .. '', "CENTER", 1)
					self:SetCellScript(itemInList+rowOffset, 2, "OnMouseUp", function ()
						v.quantity = 0
						TextLib:TextMessage(select(1, GetItemInfo(v.id)) .. " quantity has been reset")
						end)

					self:SetCell(itemInList+rowOffset, 3, v.rate, "CENTER", 1)

					itemInList = itemInList + 1
				end 
				
				]]

		 		end
		 		end 
		 		end)
		
		tooltip.OnRelease = 
			function()
				--tooltip:ClearAllPoints();
				tooltip = nil
			end

		if IsDetached() then
	        tooltip:Show()
	        LibQTip.layoutCleaner:CleanupLayouts()
			tooltip:ClearAllPoints()
			tooltip:SetPoint("BOTTOMLEFT",detachframe)
			tooltip:SetFrameLevel(detachframe:GetFrameLevel()+1)
	   else
	        tooltip:SmartAnchorTo(anchorframe)
			tooltip:SetAutoHideDelay(0.1, anchorframe, closeToolTip)
	        tooltip:Show()
	   end
end
dingle = 0


DT_Frame:SetScript("OnEnter",
	function(self, m)
		DT_Frame_FS:SetAlpha(1.0)
		DT_Reset:SetAlpha(1.0)
		isMouseOver = true
		if not IsDetached() then showToolTip(DT_Frame) end
	end
)

DT_Frame:SetScript("OnLeave",
	function(self, m)
		fadeTime = GetTime()
		isMouseOver = false
	end
)

DT_EDITBOX:SetScript("OnEnter",
	function(self, m)
		DT_Frame_FS:SetAlpha(1.0)
		DT_Reset:SetAlpha(1.0)
		isMouseOver = true
		--anchor_OnEnter(self)
	end
)

DT_EDITBOX:SetScript("OnLeave",
	function(self, m)
		fadeTime = GetTime()
		isMouseOver = false
		--anchor_OnLeave(self)
	end
)

DT_Reset:SetScript("OnClick",
	function(self)
		ToggleDetached()
	end
)

DT_Frame:SetScript("OnMouseDown",
	function(self, button)
		if(button == "LeftButton") then
			isMoving = true
			self:StartMoving()
		end
	end
)

DT_Frame:SetScript("OnMouseUp",
	function(self, button)
		if(isMoving) then
			isMoving = false
			self:StopMovingOrSizing()
		end
	end
)	

DT_Reset:SetScript("OnEnter",
	function(self, m)
		DT_Frame_FS:SetAlpha(1.0)
		DT_Reset:SetAlpha(1.0)
		isMouseOver = true
	end
)

DT_Reset:SetScript("OnLeave",
	function(self, m)
		fadeTime = GetTime()
		isMouseOver = false
	end
)



local function splitLootMsg(chatMsg) 
	local output = {itemLink = nil, quantity = nil, obtainType = nil}

	if not chatMsg then return "notValid", -1 end
	
	local obtain = string.match(chatMsg, "You (.-):") -- : \[(.-)\] x(%d+)
	--print (obtain)
	local obtainRC = string.match(obtain, "")
	if (string.find(obtain, "receives?") or string.find(obtain, "creates?")) then
		--print(obtain .. "    : Contains receives/creates")
	else
		return "notValid", -1
	end

	local itemLink = string.match(chatMsg, ": (.*%|r)") -- : \[(.-)\] x(%d+)
	--print (itemLink)

	local quan = string.match(chatMsg, "x(%d+).") -- : \[(.-)\] x(%d+)
	if (quan == nil) then
		quan = 1
	end
	--print (quan)


	null, colorStr, dataStr, idk = splitItem(itemLink)
	    local scrap = resolveItem(dataStr)
	    local itemId = scrap[1]
	    --print(itemId)
	return itemId, quan
end

local function handleLootMsg(self, event, chatMsg, chatLineID) 
	--print(chatMsg)
	local id, quantity = splitLootMsg(chatMsg)
	for k,v in pairs(trackedItems) do
		if (id == v.id) then
			v.quantity = v.quantity + quantity
			print(DT_HEADER .. select(1, GetItemInfo(v.id)) .. " now at " .. v.quantity)
			TextLib:TextMessage(select(1, GetItemInfo(v.id)) .. " now at " .. v.quantity)
		end
	end

end

local function DT_OnEvent(self, event, ...)
	if(event == "ADDON_LOADED") then
		--print("Addon Loaded")
		for i=1,select("#", ...) do
			local AddOnName = select(i, ...)
			--print(AddOnName)
			if(AddOnName == "DropTrak") then
				DT_money = GetMoney()
				start_gold = GetMoney()
				Update_Gold() 
				print(DT_HEADER.. DT_VERSION.." Loaded.")
				TextLib:TextMessage(DT_HEADER .. DT_VERSION.. " Loaded")

				if (dropTrakData == nil) then
					dropTrakData = {frames = {}, trackedItems = {}}
				end
				trackedItems = dropTrakData.trackedItems
				frames = dropTrakData.frames

				for k,v in pairs(trackedItems) do
					v.quantity = 0;
					v.rate = 0;
				end
			end
		end
	end

	if (event == "PLAYER_LOGOUT") then
		dropTrakData.trackedItems = trackedItems
		dropTrakData.frames = frames
	end

	if(event == "PLAYER_MONEY") then
		Update_Gold()
	end
	
	if(event == "PLAYER_LOGIN") then
		DT_money	= GetMoney()
		start_gold 	= GetMoney()

		SkinFrame(DT_Frame, DT_Frame:GetName())
	end

	if (event == "CHAT_MSG_LOOT") then
		handleLootMsg(self, event, ...)
	end

	--[[ We may just use the IsAltKeyDown() stuff instead as that will also ensure the key is pressed just with a delay for
	the update as our frame updates twice a second (every 0.5 secs)
	if (event == "MODIFIER_STATE_CHANGED") then
		local key, isPressed = select(1, ...)
		print(DT_HEADER .. " key:" .. key .. " state: " .. isPressed)
	end
	]]--
end

DT_Frame:SetScript("OnEvent", DT_OnEvent)
DT_Frame:SetScript("OnUpdate", DT_OnUpdate)




function IsDetached()
  return detachframe and detachframe:IsShown()
end
function HideDetached()
  detachframe:Hide()
end
function ToggleDetached()
   if IsDetached() then
     HideDetached()
   else
     ShowDetached()
   end
end

function ShowDetached()
    if not detachframe then
      local f = CreateFrame("Frame","DropTrakDetached",UIParent,"BasicFrameTemplate")
      f:SetMovable(true)
      f:SetFrameStrata("TOOLTIP")
      f:SetFrameLevel(100)
      f:SetClampedToScreen(true)
      f:EnableMouse(true)
      f:SetUserPlaced(true)
      f:SetAlpha(0.5)
      if frames.detachedX and frames.detachedY then
        f:SetPoint("TOPLEFT",frames.detachedX,-frames.detachedY)
      else
        f:SetPoint("CENTER")
      end
      f:SetScript("OnMouseDown", function() f:StartMoving() end)
      f:SetScript("OnMouseUp", function() f:StopMovingOrSizing()
                      frames.detachedX = f:GetLeft()
                      frames.detachedY = UIParent:GetTop() - (f:GetTop()*f:GetScale())
                  end)
      f:SetScript("OnHide", function() if tooltip then LibQTip:Release(tooltip); tooltip = nil end  end )
      f:SetScript("OnUpdate", function(self)
		  if not tooltip then f:Hide(); return end
		  local w,h = tooltip:GetSize()
		  self:SetSize(w*tooltip:GetScale(),(h+20)*tooltip:GetScale())
		end)
      f:SetScript("OnKeyDown", function(self,key) 
        if key == "ESCAPE" then 
	   f:SetPropagateKeyboardInput(false)
	   f:Hide(); 
	end 
      end)
      f:EnableKeyboard(true)
      detachframe = f
    end
    local f = detachframe
    f:Show()
    SkinFrame(f,f:GetName())
    f:SetPropagateKeyboardInput(true)
    if tooltip then tooltip:Hide() end
    showToolTip(f)
end

