local MAJOR = "LibTextMsg-1.0"
local MINOR = 1 -- Should be manually increased
assert(LibStub, MAJOR .. " requires LibStub")

local lib, oldminor = LibStub:NewLibrary(MAJOR, MINOR)
if not lib then return end -- No upgrade needed

if not lib.showTime then
	lib.showTime = 3
end
if not lib.prefix then
	lib.prefix = "|cffff00ffTextLib::|r"
end

if not lib.MOD_TextFrame then
  	lib.MOD_TextFrame=CreateFrame("MessageFrame")
	lib.MOD_TextFrame:ClearAllPoints();
	lib.MOD_TextFrame:SetHeight(300);
	lib.MOD_TextFrame:SetWidth(500);
	lib.MOD_TextFrame:SetScript("OnUpdate", lib.TextFrame_OnUpdate);
	lib.MOD_TextFrame:Hide();

	lib.MOD_TextFrame:SetFontObject("GameFontHighlightOutline")
	lib.MOD_TextFrame:SetInsertMode("TOP")
	lib.MOD_TextFrame:SetTimeVisible(2.5)
	lib.MOD_TextFrame:SetFadeDuration(2)

	lib.MOD_TextFrame:SetPoint("CENTER", 0, 100);

end

if not lib.MOD_TextFrameTime then
	lib.MOD_TextFrameTime = 0;
end

function lib:SetPrefix(prefix)
	lib.prefix = prefix
end
	

function lib:TextMessage(message)
	  --MOD_TextFrame.text:SetText("TextLib :: " .. tostring(message));
	  lib.MOD_TextFrame:AddMessage("|cffff00ffTextLib::|r"..tostring(message))
	  lib.MOD_TextFrame:SetAlpha(1);
	  lib.MOD_TextFrame:Show();
	  lib.MOD_TextFrameTime = GetTime();
end

function lib:TextMessage(prefix, message)
	  --MOD_TextFrame.text:SetText("TextLib :: " .. tostring(message));
	  lib.MOD_TextFrame:AddMessage(tostring(prefix)..tostring(message))
	  lib.MOD_TextFrame:SetAlpha(1);
	  lib.MOD_TextFrame:Show();
	  lib.MOD_TextFrameTime = GetTime();
end

function lib:SetShowTime(time)
	lib.showTime = time
end
